import { NamingStrategy } from "../../naming-strategy/NamingStrategy";
/**
 * This metadata interface contains all information about specific table.
 */
export declare class TableMetadata {
    /**
     * Naming strategy used to generate and normalize table name.
     */
    namingStrategy: NamingStrategy;
    /**
     * Class to which this column is applied.
     */
    readonly target: Function;
    /**
     * Indicates if this table is abstract or not. Regular tables can inherit columns from abstract tables.
     */
    readonly isAbstract: boolean;
    /**
     * Table name in the database.
     */
    private _name;
    constructor(target?: Function, name?: string);
    constructor(target: Function, isAbstract: boolean);
    /**
     * Table name in the database.
     */
    readonly name: any;
}
