"use strict";
/**
 * This metadata interface contains all information about specific table.
 */
var TableMetadata = (function () {
    function TableMetadata(target, nameOrIsAbstract, maybeIsAbstract) {
        /**
         * Indicates if this table is abstract or not. Regular tables can inherit columns from abstract tables.
         */
        this.isAbstract = false;
        if (target)
            this.target = target;
        if (typeof nameOrIsAbstract === "string")
            this._name = nameOrIsAbstract;
        if (typeof nameOrIsAbstract === "boolean")
            this.isAbstract = nameOrIsAbstract;
        if (typeof maybeIsAbstract === "boolean")
            this.isAbstract = maybeIsAbstract;
    }
    Object.defineProperty(TableMetadata.prototype, "name", {
        // ---------------------------------------------------------------------
        // Getters
        // ---------------------------------------------------------------------
        /**
         * Table name in the database.
         */
        get: function () {
            if (this._name)
                return this._name;
            return this.namingStrategy ? this.namingStrategy.tableName(this.target.name) : this.target.name;
        },
        enumerable: true,
        configurable: true
    });
    return TableMetadata;
}());
exports.TableMetadata = TableMetadata;
//# sourceMappingURL=TableMetadata.js.map